#pragma once
#include "ThreadJob.h"
#include "define.h"					// pPbg쐬̂

#define	CMD_BUFF_SIZE	(1024 * 64)	// t@CMR}h/i[Oobt@̃TCY

// t@CMJڏ
#define RECV_FILE_STAT_IDLE		0	// 
#define RECV_FILE_STAT_SIZE		1	// t@CM MTCYv҂
#define RECV_FILE_STAT_START	2	// t@CMJnv
#define RECV_FILE_STAT_ING		3	// t@CM
#define RECV_FILE_STAT_END		4	// t@CMM
#define RECV_FILE_STAT_ABORT	5	// t@CMfv҂


class CMySyncObject;				// CMySyncObjectg
class CSendRecvThread;				// CSendRecvThreadg
class CRingBuff;					// CRingBuffg

class CRecvFileThread :
	public CThreadJob
{
public:
	CRecvFileThread(CSendRecvThread *pCSendRecvThread, LPSTR pszFileName);
	~CRecvFileThread();

	CRingBuff	*m_pCRingBuffCmd;			// t@CMR}h/i[Oobt@

	UINT DoWork() override;
	BOOL IsZombie();						// ̃Xbh̓]rԂ
	BOOL RecvFileAbort();					// t@CM̒f

private:
	LPSTR			m_pszFileName;			// Mt@C
	CSendRecvThread	*m_pCSendRecvThread;	// MXbh(eXbh)
	CMySyncObject	*m_pCMySyncObject;
	BOOL			m_fIamZombie;			// ]rԂ(MI)

	int				m_iRecvFileStatus;		// Jڏ RECV_FILE_STAT_IDLE/RECV_FILE_STAT_SIZE/RECV_FILE_STAT_START
											// RECV_FILE_STAT_ING/RECV_FILE_STAT_ABORT

	char			m_cRecvFileSizeRes;		// t@CM MTCYv(0:l 1:OK -1:G[)
	long			m_lRecvFileSize;		// MTCY (G[:0 ݎ:ۂ̃TCY)
	char			m_cRecvFileAbortRes;	// t@CMfv(0:l 1:OK -1:G[)
	DWORD			m_dwStart;				// ҂^CAEĝߗvs

	int				m_fdDstFile;			// Mt@CfBXNv^

	int DoRecvFileState();					// JڏԂɉt@CM,s
	// t@CM
	int SendRecvFileSize();						// t@CMTCYv
	BOOL SendRecvFileSizePacket(LPSTR pszFileName);
	int	CheckRecvFileSizeRes(DWORD dwTimeOut);	// t@CMTCYv`FbN
	int SendRecvFileStart();					// t@CMJnv
	BOOL SendRecvFileStartPacket(LPSTR pszFileName, int iFileLength);
	BOOL SendRecvFileAbortPacket();				// t@CM̒fvM
	int	CheckRecvFileAbortRes(DWORD dwTimeOut);	// t@CM̒fv`FbN
	

	// 
	int AnalyzeCmd();							// t@CMR}h/pPbg̉
	int RecvRecvFileSizeResPacket(RecvFileSizeResRec *pbPacket);	// t@CMTCYv
	int RecvRecvFileIngPacket(RecvFileIngRec *pbPacket);			// t@CM
	int RecvRecvFileEndPacket(RecvFileEndReqRec *pbPacket);			// t@CM
	BOOL SendRecvFileEndResPacket(char cResCode);					// t@CMvɑ΂鉞𑗐M
	int RecvRecvFileAbortResPacket(RecvFileResRec *pbPacket);		// t@CMfv
};

